/* Copyright(C)URARA-works 2006 */
/* ========================================================================= */
/* t@CF	CharTAMA.cpp												 */
/* eF		LNX(\\) t@C							 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2006/05/06													 */
/* ========================================================================= */

#include "stdafx.h"
#include "../MgrGrpData.h"
#include "../lib/Img32.h"
#include "CharTAMA.h"


/* ========================================================================= */
/* ֐F	CCharTAMA::CCharTAMA											 */
/* eF	RXgN^													 */
/* tF	2006/05/06														 */
/* ========================================================================= */

CCharTAMA::CCharTAMA()
{
	m_nAnime				= 0;
	m_dwTimeLastProcAnime	= 0;
	m_dwTimeLastProcMove	= 0;
}


/* ========================================================================= */
/* ֐F	CCharTAMA::~CCharTAMA											 */
/* eF	fXgN^													 */
/* tF	2006/05/06														 */
/* ========================================================================= */

CCharTAMA::~CCharTAMA()
{
}


/* ========================================================================= */
/* ֐F	CCharTAMA::Create												 */
/* eF	쐬															 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharTAMA::Create(CMgrGrpData *pMgrGrpData, int nType)
{
	PCImg32 pImgTmp;

	CCharBase::Create (pMgrGrpData, nType);

	pImgTmp = m_pMgrGrpData->GetDibPlayer ();

	m_pImg = new CImg32;
	m_pImg->CreateWithoutGdi (8 * 3 * 2, 8 * 2);
	m_pImg->SetColorKey (RGB (255, 0, 255));

	/* Kvȕ摜Rs[ */
	m_pImg->Blt (0, 0, 8 * 3 * 2, 8 * 2, pImgTmp, 148 * 2, m_nType * 16 * 2);
}


/* ========================================================================= */
/* ֐F	CCharTAMA::Draw													 */
/* eF	`															 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharTAMA::Draw(CImg32 *pImgDst)
{
	pImgDst->Blt (
			m_ptPos.x,
			m_ptPos.y,
			16, 16, m_pImg,
			m_nAnime * 16,
			0,
			TRUE);
}


/* ========================================================================= */
/* ֐F	CCharTAMA::Proc													 */
/* eF																 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharTAMA::Proc(void)
{
	DWORD dwTmp, dwTime;

	dwTime = timeGetTime ();

	dwTmp = dwTime - m_dwTimeLastProcMove;
	if (dwTmp < 10) {
		goto Exit;
	}
	if (m_dwTimeLastProcMove == 0) {
		m_dwTimeLastProcMove = dwTime;
		goto Exit;
	}

	/* 10~b1t[ */
	dwTmp /= 10;

	m_dwTimeLastProcMove = dwTime;

	switch (m_nState) {
	case CHARSTATE_IDLE:		ProcMOVE_IDLE	(dwTmp);	break;	/* ҋ@ */
	case CHARSTATE_MOVE_RIGHT:	ProcMOVE_RIGHT	(dwTmp);	break;	/* Eֈړ */
	case CHARSTATE_MOVE_LEFT:	ProcMOVE_LEFT	(dwTmp);	break;	/* ֈړ */
	case CHARSTATE_DESTROY_1:	ProcDESTROY_1	(dwTime);	break;	/* Œ1 */
	case CHARSTATE_DESTROY_2:	ProcDESTROY_2	(dwTime);	break;	/* Œ2 */
	case CHARSTATE_DESTROY:		m_bDestroy = TRUE;			break;	/*  */
	}

Exit:
	return;
}


/* ========================================================================= */
/* ֐F	CCharTAMA::SetPos												 */
/* eF	Wݒ														 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharTAMA::SetPos(POINT ptPos)
{
	CCharBase::SetPos (ptPos);

	m_ptStart = ptPos;
}


/* ========================================================================= */
/* ֐F	CCharTAMA::ProcMOVE_IDLE										 */
/* eF	(ҋ@)													 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharTAMA::ProcMOVE_IDLE(DWORD dwTime)
{
}


/* ========================================================================= */
/* ֐F	CCharTAMA::ProcMOVE_RIGHT										 */
/* eF	(Eֈړ)												 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharTAMA::ProcMOVE_RIGHT(DWORD dwTime)
{
	m_nDirection = 0;
	m_ptPos.x += (dwTime * 4);

	if (abs (m_ptPos.x - m_ptStart.x) > 32 * 7) {
		m_dwTimeLastProcAnime = 0;
		ChgState (CHARSTATE_DESTROY_1);
	}
}


/* ========================================================================= */
/* ֐F	CCharTAMA::ProcMOVE_LEFT										 */
/* eF	(ֈړ)												 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharTAMA::ProcMOVE_LEFT(DWORD dwTime)
{
	m_nDirection = 1;
	m_ptPos.x -= (dwTime * 4);

	if (abs (m_ptPos.x - m_ptStart.x) > 32 * 7) {
		m_dwTimeLastProcAnime = 0;
		ChgState (CHARSTATE_DESTROY_1);
	}
}


/* ========================================================================= */
/* ֐F	CCharTAMA::ProcDESTROY_1										 */
/* eF	(Œ1)													 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharTAMA::ProcDESTROY_1(DWORD dwTime)
{
	m_nAnime = 1;

	if (m_dwTimeLastProcAnime == 0) {
		m_dwTimeLastProcAnime = dwTime;
		return;
	}
	if (dwTime - m_dwTimeLastProcAnime < 50) {
		return;
	}

	/* Aj[VXV */
	m_dwTimeLastProcAnime = 0;
	ChgState (CHARSTATE_DESTROY_2);
}


/* ========================================================================= */
/* ֐F	CCharTAMA::ProcDESTROY_2										 */
/* eF	(Œ2)													 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharTAMA::ProcDESTROY_2(DWORD dwTime)
{
	m_nAnime = 2;

	if (m_dwTimeLastProcAnime == 0) {
		m_dwTimeLastProcAnime = dwTime;
		return;
	}
	if (dwTime - m_dwTimeLastProcAnime < 50) {
		return;
	}

	/* Aj[VXV */
	m_dwTimeLastProcAnime = 0;
	ChgState (CHARSTATE_DESTROY);
}

/* Copyright(C)URARA-works 2006 */
