/* Copyright(C)URARA-works 2006 */
/* ========================================================================= */
/* t@CF	MainFrame.h													 */
/* eF		Ct[ t@C									 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2006/03/29													 */
/* ========================================================================= */

#include "stdafx.h"
#include "resource.h"
#include "Lib/Img32.h"
#include "StateProc/StateProc.h"
#include "CommonDefine.h"
#include "MgrGrpData.h"
#include "MgrSound.h"
#include "MgrKeyInput.h"
#include "MainFrame.h"


/* ========================================================================= */
/* 萔`																	 */
/* ========================================================================= */

#define CLNAME "SonSon"							/* o^NX */


/* ========================================================================= */
/* ֐F	CMainFrame::CMainFrame											 */
/* eF	RXgN^													 */
/* tF	2006/03/29														 */
/* ========================================================================= */

CMainFrame::CMainFrame()
{
	m_hWnd			= NULL;
	m_bWindowActive	= TRUE;
	m_nGameState	= GAMESTATE_PRODUCT;

	m_pImgBack		= new CImg32;
	m_pMgrGrpData	= new CMgrGrpData;
	m_pMgrSound		= new CMgrSound;
	m_pMgrKeyInput	= new CMgrKeyInput;
	m_pStateProc	= NULL;

	CoInitialize (NULL);
}


/* ========================================================================= */
/* ֐F	CMainFrame::~CMainFrame											 */
/* eF	fXgN^													 */
/* tF	2006/03/29														 */
/* ========================================================================= */

CMainFrame::~CMainFrame()
{
	SAFE_DELETE (m_pImgBack);
	SAFE_DELETE (m_pMgrGrpData);
	SAFE_DELETE (m_pMgrSound);
	SAFE_DELETE (m_pMgrKeyInput);
	SAFE_DELETE (m_pStateProc);

	CoUninitialize ();
}


/* ========================================================================= */
/* ֐F	CMainFrame::MainLoop											 */
/* eF	C[v													 */
/* tF	2006/03/29														 */
/* ========================================================================= */

int CMainFrame::MainLoop(HINSTANCE hInstance)
{
	char szBuf[256];
	BYTE byFps, byNowFrame, byFrameBack;
	DWORD dwStyle, dwTmp, dwTimeTmp, dwTimeFps, dwTimeStart;
	BOOL bResult, bDraw;
	RECT rcTmp;
	MSG msg;
	TIMECAPS tc;
	WNDCLASS wc;

	wc.hInstance		= hInstance;
	wc.lpszClassName	= CLNAME;
	wc.lpfnWndProc		= (WNDPROC)WndProcEntry;
	wc.style			= 0;
	wc.hIcon			= NULL;//LoadIcon (hInstance, (char *)IDI_MAINFRAME);
	wc.hCursor			= LoadCursor ((HINSTANCE)NULL, IDC_ARROW);
	wc.lpszMenuName		= NULL;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hbrBackground	= (HBRUSH)GetStockObject (BLACK_BRUSH);

	/* EBhẼNXo^ */
	if (!RegisterClass (&wc)) {
		return FALSE;
	}

	/* EBhETCYvZ */
	dwStyle = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_CLIPCHILDREN | WS_MINIMIZEBOX;
	SetRect (&rcTmp, 0, 0, DRAWSIZEX * 2, DRAWSIZEY * 2);
	AdjustWindowRect (&rcTmp, dwStyle, FALSE);

	/* EBhE쐬 */
	wsprintf (szBuf, "%s", "\\Ă݂悤 Ver.060603");
	m_hWnd = CreateWindow (
				CLNAME,
				szBuf,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT,
				rcTmp.right - rcTmp.left, rcTmp.bottom - rcTmp.top,
				NULL,
				NULL,
				hInstance,
				this);
	if (m_hWnd == NULL) {
		return FALSE;
	}

	ShowWindow (m_hWnd, SW_SHOW);

	timeGetDevCaps (&tc, sizeof (TIMECAPS));
	/* }`fBA^C}[̃T[rXxő */
	timeBeginPeriod (tc.wPeriodMin);

	byFps		= 0;
	dwTmp		= 33;
	byFrameBack	= 0;
	dwTimeStart	= timeGetTime ();

	while (1) {
		if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE)) {
			if (msg.message == WM_QUIT) {
				break;
			}
			TranslateMessage (&msg);
			DispatchMessage (&msg);

		} else {
			bResult		= TimerProc ();
			dwTimeTmp	= timeGetTime ();
			bDraw		|= bResult;

			/* ԓIɕ`悷邾낤t[ԍ߂ */
			byNowFrame = (BYTE)((dwTimeTmp - dwTimeStart) / dwTmp);
			if ((byFps < 30) && (byFrameBack != byNowFrame)) {
				if (bDraw) {
					InvalidateRect (m_hWnd, NULL, FALSE);
					bDraw = FALSE;
					byFps ++;
				}
				byFrameBack = byNowFrame;
			}

			MsgWaitForMultipleObjects (0, NULL, FALSE, 1, QS_ALLINPUT);

			if (timeGetTime () > dwTimeStart + 1000) {
				/* FPS̍XV */
				dwTimeStart = dwTimeFps = timeGetTime ();
				byFps = 0;
			}
		}
	}

	timeEndPeriod (tc.wPeriodMin);
	UnregisterClass (CLNAME, hInstance);

	/* IbZ[WɂvOI */
	return (int)msg.wParam;
}


/* ========================================================================= */
/* ֐F	CMainFrame::WndProcEntry										 */
/* eF	CEBhEvV[W(Gg|Cg)					 */
/* tF	2006/03/29														 */
/* ========================================================================= */

LRESULT CALLBACK CMainFrame::WndProcEntry(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	CMainFrame* pThis;

	if (msg == WM_CREATE) {
		SetWindowLong (hWnd, GWL_USERDATA, (LONG)(((LPCREATESTRUCT)lParam)->lpCreateParams));
	}

	/* [Uf[^ this |C^擾As */
	pThis = (CMainFrame *)GetWindowLong (hWnd, GWL_USERDATA);
	if (pThis) {
		return pThis->WndProc (hWnd, msg, wParam, lParam);
	}
	return DefWindowProc (hWnd, msg, wParam, lParam);
}


/* ========================================================================= */
/* ֐F	CMainFrame::WndProc												 */
/* eF	CEBhEvV[W									 */
/* tF	2006/03/29														 */
/* ========================================================================= */

LRESULT CMainFrame::WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
	HANDLE_MSG (hWnd, WM_CREATE,	OnCreate);
	HANDLE_MSG (hWnd, WM_DESTROY,	OnDestroy);
	HANDLE_MSG (hWnd, WM_PAINT,		OnPaint);

	case WM_INIT:
		OnInit (hWnd, wParam, lParam);
		break;

	default:
		return DefWindowProc (hWnd, msg, wParam, lParam);
	}
	return 0;
}


/* ========================================================================= */
/* ֐F	CMainFrame::OnCreate											 */
/* eF	bZ[Wnh(WM_CREATE)									 */
/* tF	2006/03/29														 */
/* ========================================================================= */

BOOL CMainFrame::OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct)
{
	m_pMgrKeyInput->Create ();
	m_pMgrGrpData->Load ();
	m_pMgrSound->Create ();

	m_pImgBack->Create (DRAWSIZEX * 2, DRAWSIZEY * 2);

	PostMessage (hWnd, WM_INIT, 0, 0);

	return TRUE;
}


/* ========================================================================= */
/* ֐F	CMainFrame::OnInit												 */
/* eF	bZ[Wnh(WM_INIT)										 */
/* tF	2006/05/21														 */
/* ========================================================================= */

void CMainFrame::OnInit(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
//test
	ChgGameState(GAMESTATE_GAME);
}


/* ========================================================================= */
/* ֐F	CMainFrame::OnDestroy											 */
/* eF	bZ[Wnh(WM_DESTROY)									 */
/* tF	2006/03/29														 */
/* ========================================================================= */

void CMainFrame::OnDestroy(HWND hWnd)
{
	PostQuitMessage (0);
}


/* ========================================================================= */
/* ֐F	CMainFrame::OnPaint												 */
/* eF	bZ[Wnh(WM_PAINT)									 */
/* tF	2006/03/29														 */
/* ========================================================================= */

void CMainFrame::OnPaint(HWND hWnd)
{
	PAINTSTRUCT ps;
	HDC hDC, hDCTmp;

	hDC = BeginPaint (hWnd, &ps);

	if (m_pStateProc) {
		m_pStateProc->Draw (m_pImgBack);
		hDCTmp = m_pImgBack->Lock ();

		BitBlt (hDC, 0, 0, DRAWSIZEX * 2, DRAWSIZEY * 2, hDCTmp, 0, 0, SRCCOPY);
		
		m_pImgBack->Unlock ();
	}

	EndPaint (hWnd, &ps);
}


/* ========================================================================= */
/* ֐F	CMainFrame::TimerProc											 */
/* eF	^C}[													 */
/* tF	2006/03/29														 */
/* ========================================================================= */

BOOL CMainFrame::TimerProc(void)
{
	int i;
	BOOL bDown, bResult;
	BYTE byCode, byCodeTmp, abyCode[] = {VK_UP, VK_DOWN, VK_LEFT, VK_RIGHT, 0};

	if (m_pStateProc) {
		m_pStateProc->Proc ();

		m_pMgrKeyInput->Renew (byCode, bDown);
		if (byCode == 0) {
			for (i = 0; ; i ++) {
				byCodeTmp = abyCode[i];
				if (byCodeTmp == 0) {
					break;
				}
				bResult = m_pMgrKeyInput->IsInput (byCodeTmp);
				if (bResult) {
					byCode	= byCodeTmp;
					bDown	= TRUE;
					break;
				}
			}
		}

		switch (byCode) {
		case VK_UP:		m_pStateProc->OnKeyUp		(bDown);	break;
		case VK_DOWN:	m_pStateProc->OnKeyDown		(bDown);	break;
		case VK_LEFT:	m_pStateProc->OnKeyLeft		(bDown);	break;
		case VK_RIGHT:	m_pStateProc->OnKeyRight	(bDown);	break;
		case 'X':		m_pStateProc->OnKeyX		(bDown);	break;
		case 'Z':		m_pStateProc->OnKeyZ		(bDown);	break;
		}
	}

	return TRUE;
}


/* ========================================================================= */
/* ֐F	CMainFrame::ChgGameState										 */
/* eF	Q[Ԃ؂ւ											 */
/* tF	2006/04/29														 */
/* ========================================================================= */

void CMainFrame::ChgGameState(int nGameState)
{
	m_nGameState = nGameState;

	SAFE_DELETE (m_pStateProc);

	switch (m_nGameState) {
	case GAMESTATE_PRODUCT:				/* v_Ng\ */
	case GAMESTATE_TITLE:				/* ^Cg\ */
	case GAMESTATE_CHARSELECT:			/* LI */
	case GAMESTATE_STARTGAME:			/* Q[Jn */
		break;
	case GAMESTATE_GAME:				/* Q[ */
		m_pStateProc = new CStateProcGAME;
		break;
	case GAMESTATE_GAMEOVER:			/* Q[I[o[ */
		break;
	}

	if (m_pStateProc) {
		m_pStateProc->Create (m_pMgrGrpData, m_pMgrSound);
	}
}

/* Copyright(C)URARA-works 2006 */
