/* Copyright(C)URARA-works 2006 */
/* ========================================================================= */
/* t@CF	MgrSound.cpp												 */
/* eF		TEhf[^ǗNX t@C						 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2006/05/09													 */
/* ========================================================================= */

#include "StdAfx.h"
#include "resource.h"
#include "Lib/DXAudio.h"
#include "MgrSound.h"


/* ========================================================================= */
/* ֐F	CMgrSound::CMgrSound											 */
/* eF	RXgN^													 */
/* tF	2006/05/09														 */
/* ========================================================================= */

CMgrSound::CMgrSound()
{
	m_pDXAudio	= new CDXAudio;
	m_apDMSBGM	= NULL;

	ZeroMemory (m_apDMSSound, sizeof (m_apDMSSound));
}


/* ========================================================================= */
/* ֐F	CMgrSound::~CMgrSound											 */
/* eF	fXgN^													 */
/* tF	2006/05/09														 */
/* ========================================================================= */

CMgrSound::~CMgrSound()
{
	Destroy ();

	SAFE_DELETE (m_pDXAudio);
}


/* ========================================================================= */
/* ֐F	CMgrSound::Create												 */
/* eF	쐬															 */
/* tF	2006/05/09														 */
/* ========================================================================= */

BOOL CMgrSound::Create(void)
{
	BOOL bRet, bResult;
	int i, anResoutce[] = {
		IDR_INTRO,
		IDR_START,
		IDR_TAMA,
		0
	};

	bRet = FALSE;

	bResult = m_pDXAudio->Create ();
	if (bResult == FALSE) {
		goto Exit;
	}

	/* BGMǂݍ */
	m_pDXAudio->GetSegFromRes (
			FindResource (NULL, MAKEINTRESOURCE (IDR_BGM), "WAVE"),
			&m_apDMSBGM);
	m_pDXAudio->SetLoopPoints (m_apDMSBGM, DMUS_SEG_REPEAT_INFINITE);
	m_pDXAudio->SetVolPrimary (0);

	/* ʉǂݍ */
	for (i = 0; anResoutce[i] != 0; i ++) {
		m_pDXAudio->GetSegFromRes (
				FindResource (NULL, MAKEINTRESOURCE (anResoutce[i]), "WAVE"),
				&m_apDMSSound[i]);
	}

	bRet = TRUE;
Exit:
	return bRet;
}


/* ========================================================================= */
/* ֐F	CMgrSound::Destroy												 */
/* eF	j															 */
/* tF	2006/05/09														 */
/* ========================================================================= */

void CMgrSound::Destroy(void)
{
	if (m_pDXAudio) {
		m_pDXAudio->Destroy ();
	}
}


/* ========================================================================= */
/* ֐F	CMgrSound::PlaySound											 */
/* eF	ʉ̍Đ													 */
/* tF	2006/05/09														 */
/* ========================================================================= */

void CMgrSound::PlaySound(int nNo)
{
	IDirectMusicSegment8 *pDMS;

	if (nNo >= SONSONSOUND_MAX) {
		return;
	}

	pDMS = m_apDMSSound[nNo - 1];
	if (pDMS == NULL) {
		return;
	}
	m_pDXAudio->PlaySecoundary (pDMS);
}


/* ========================================================================= */
/* ֐F	CMgrSound::PlayBGM												 */
/* eF	BGM̍Đ														 */
/* tF	2006/05/09														 */
/* ========================================================================= */

void CMgrSound::PlayBGM(void)
{
	if (m_apDMSBGM == NULL) {
		return;
	}

	m_pDXAudio->PlayPrimary (m_apDMSBGM);
}


/* ========================================================================= */
/* ֐F	CMgrSound::StopBGM												 */
/* eF	BGM̒~														 */
/* tF	2006/05/09														 */
/* ========================================================================= */

void CMgrSound::StopBGM(void)
{
	if (m_apDMSBGM == NULL) {
		return;
	}

	m_pDXAudio->Stop (m_apDMSBGM, 0);
}

/* Copyright(C)URARA-works 2006 */
