/* Copyright(C)URARA-works 2006 */
/* ========================================================================= */
/* t@CF	StateProcGAME.cpp											 */
/* eF		ԕʏ(Q[)NX t@C						 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2006/04/23													 */
/* ========================================================================= */

#include "stdafx.h"
#include "../CommonDefine.h"
#include "../Lib/Img32.h"
#include "../Char/CharSONSON.h"
#include "../Char/CharTAMA.h"
#include "../MgrSound.h"
#include "StateProcGAME.h"


/* ========================================================================= */
/* ֐F	CStateProcGAME::CStateProcGAME									 */
/* eF	RXgN^													 */
/* tF	2006/04/23														 */
/* ========================================================================= */

CStateProcGAME::CStateProcGAME()
{
	m_nTestCharType = 0;
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::~CStateProcGAME									 */
/* eF	fXgN^													 */
/* tF	2006/04/23														 */
/* ========================================================================= */

CStateProcGAME::~CStateProcGAME()
{
	Destroy ();
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::Create											 */
/* eF	쐬															 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CStateProcGAME::Create(CMgrGrpData *pMgrGrpData, CMgrSound *pMgrSound)
{
	PCCharBase pChar;

	CStateProcBase::Create (pMgrGrpData, pMgrSound);

	pChar = new CCharSONSON;
	pChar->Create (pMgrGrpData, m_nTestCharType);
	m_aCharInfo.Add (pChar);
	m_pPlayer = pChar;

	m_pMgrSound->PlayBGM ();
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::Destroy											 */
/* eF	j															 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CStateProcGAME::Destroy(void)
{
	DeleteCharAll ();
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::Draw											 */
/* eF	`															 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CStateProcGAME::Draw(CImg32 *pImgDst)
{
	int i, nCount;
	PCCharBase pChar;

	/* wi̕` */
	pImgDst->FillRect (0, 0, DRAWSIZEX * 2, DRAWSIZEY * 2, RGB (0, 0, 0));

	/* L̕` */
	nCount = m_aCharInfo.GetSize ();
	for (i = 0; i < nCount; i ++) {
		pChar = m_aCharInfo[i];

		pChar->Draw (pImgDst);
	}
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::Proc											 */
/* eF																 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CStateProcGAME::Proc(void)
{
	int i, nCount;
	PCCharBase pChar;

	/* L̏ */
	nCount = m_aCharInfo.GetSize ();
	for (i = 0; i < nCount; i ++) {
		pChar = m_aCharInfo[i];

		pChar->Proc ();
		if (pChar->IsDestroy ()) {
			Delete (i);
			break;
		}
	}
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::OnKeyUp											 */
/* eF	L[()													 */
/* tF	2006/04/26														 */
/* ========================================================================= */

void CStateProcGAME::OnKeyUp(BOOL bPush)
{
	int nState;
	POINT ptPos;

	nState = m_pPlayer->GetState ();
	if (nState != CHARSTATE_IDLE) {
		return;
	}

	ptPos = m_pPlayer->GetPos ();
	if (ptPos.y <= 48) {
		return;
	}

	nState = CHARSTATE_MOVE_UP;
	m_pPlayer->ChgState (nState);
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::OnKeyDown										 */
/* eF	L[()													 */
/* tF	2006/04/26														 */
/* ========================================================================= */

void CStateProcGAME::OnKeyDown(BOOL bPush)
{
	int nState;
	POINT ptPos;

	nState = m_pPlayer->GetState ();
	if (nState != CHARSTATE_IDLE) {
		return;
	}

	ptPos = m_pPlayer->GetPos ();
	if (ptPos.y >= 400) {
		return;
	}

	nState = CHARSTATE_MOVE_DOWN;
	m_pPlayer->ChgState (nState);
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::OnKeyLeft										 */
/* eF	L[()													 */
/* tF	2006/04/26														 */
/* ========================================================================= */

void CStateProcGAME::OnKeyLeft(BOOL bPush)
{
	int nState;

	nState = m_pPlayer->GetState ();
	switch (nState) {
	case CHARSTATE_IDLE:
	case CHARSTATE_MOVE_LEFT:
		break;
	default:
		return;
	}

	if (bPush == FALSE) {
		nState = CHARSTATE_IDLE;
	} else {
		nState = CHARSTATE_MOVE_LEFT;
	}

	m_pPlayer->ChgState (nState);
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::OnKeyRight										 */
/* eF	L[()													 */
/* tF	2006/04/26														 */
/* ========================================================================= */

void CStateProcGAME::OnKeyRight(BOOL bPush)
{
	int nState;

	nState = m_pPlayer->GetState ();
	switch (nState) {
	case CHARSTATE_IDLE:
	case CHARSTATE_MOVE_RIGHT:
		break;
	default:
		return;
	}

	if (bPush == FALSE) {
		nState = CHARSTATE_IDLE;
	} else {
		nState = CHARSTATE_MOVE_RIGHT;
	}

	m_pPlayer->ChgState (nState);
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::OnKeyX											 */
/* eF	L[(X)														 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CStateProcGAME::OnKeyX(BOOL bPush)
{
	int nTmp, nType, nDirection, nState;
	POINT ptTmp;
	PCCharBase pChar;

	if (bPush == FALSE) {
		goto Exit;
	}

	ptTmp		= m_pPlayer->GetPos ();
	nType		= m_pPlayer->GetType ();
	nDirection	= m_pPlayer->GetDirection ();
	nState		= m_pPlayer->GetState ();

	switch (nState) {
	case CHARSTATE_IDLE:			/* ҋ@ */
	case CHARSTATE_MOVE_RIGHT:		/* Eֈړ */
	case CHARSTATE_MOVE_LEFT:		/* ֈړ */
	case CHARSTATE_MOVE_UP:			/* ֈړ */
	case CHARSTATE_MOVE_DOWN:		/* ֈړ */
		break;
	default:
		goto Exit;
	}

	nTmp = 24;
	if (nDirection == 1) {
		nTmp = 8;
	}
	ptTmp.x += nTmp;
	ptTmp.y += 13;

	pChar = new CCharTAMA;
	pChar->Create (m_pMgrGrpData, nType);
	pChar->SetPos (ptTmp);

	nState = CHARSTATE_MOVE_RIGHT;
	if (nDirection == 1) {
		nState = CHARSTATE_MOVE_LEFT;
	}
	pChar->ChgState (nState);
	/* eǉ */
	m_aCharInfo.Add (pChar);
	m_pMgrSound->PlaySound (SONSONSOUND_TAMA);

Exit:
	return;
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::OnKeyZ											 */
/* eF	L[(Z)														 */
/* tF	2006/05/21														 */
/* ========================================================================= */

void CStateProcGAME::OnKeyZ(BOOL bPush)
{
	if (bPush) {
		return;
	}

	m_nTestCharType ++;
	if (m_nTestCharType > 2) {
		m_nTestCharType = 0;
	}

	m_pPlayer->Destroy ();
	m_pPlayer->Create (m_pMgrGrpData, m_nTestCharType);
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::Delete											 */
/* eF	wԍ̃L폜										 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CStateProcGAME::Delete(int nNo)
{
	PCCharBase pChar;

	pChar = m_aCharInfo[nNo];
	SAFE_DELETE (pChar);

	m_aCharInfo.RemoveAt (nNo);
}


/* ========================================================================= */
/* ֐F	CStateProcGAME::DeleteCharAll									 */
/* eF	LSč폜											 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CStateProcGAME::DeleteCharAll(void)
{
	int i, nCount;

	nCount = m_aCharInfo.GetSize ();
	for (i = 0; i < nCount; i ++) {
		Delete (0);
	}
}

/* Copyright(C)URARA-works 2006 */
