/* Copyright(C)URARA-works 2005 */
/* ========================================================================= */
/* t@CF	Img32.cpp													 */
/* eF		32bitC[WNX t@C							 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2005/01/24													 */
/* ========================================================================= */

#include <windows.h>
#include "Img32.h"

/* ========================================================================= */
/* 萔̒`																 */
/* ========================================================================= */

#define HBITMAP_WITHOUT_GDI	((HBITMAP)-1)						/* ݊[h̃nhl */
#define BYTES_PER_PIXEL		(4)									/* 1hbg̃oCg */
#define BITS_PER_PIXEL		(BYTES_PER_PIXEL * 8)				/* 1hbg̃rbg */
#define	BYTES_PER_LINE(cx)	(cx * BYTES_PER_PIXEL)				/* 1C̃oCg */


/* ========================================================================= */
/* \̂̒`																 */
/* ========================================================================= */

union TARGB {
	DWORD ARGB;
	struct {
		BYTE B, G, R, A;
	};
};


/* ========================================================================= */
/* ֐F	CImg32::CImg32													 */
/* eF	RXgN^													 */
/* tF	2005/01/24														 */
/* ========================================================================= */
CImg32::CImg32(void)
{
	InitData ();
}


/* ========================================================================= */
/* ֐F	CImg32::~CImg32													 */
/* eF	fXgN^													 */
/* tF	2005/01/24														 */
/* ========================================================================= */
CImg32::~CImg32()
{
	Destroy ();
}


/* ========================================================================= */
/* ֐F	CImg32::Create													 */
/* eF	rbg}bv쐬												 */
/* tF	2005/01/24														 */
/* ========================================================================= */
BOOL CImg32::Create(
	int cx,		/* [in]  */
	int cy)		/* [in]  */
{
	BOOL bRet;
	HDC hDC;

	bRet = FALSE;

	if (m_hBmp) {
		goto Exit;
	}

	/* rbg}bvݒ */
	ZeroMemory (&m_bmpInfo, sizeof (m_bmpInfo));
	m_bmpInfo.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	m_bmpInfo.bmiHeader.biWidth			= cx;
	m_bmpInfo.bmiHeader.biHeight		= cy;
	m_bmpInfo.bmiHeader.biPlanes		= 1;
	m_bmpInfo.bmiHeader.biBitCount		= BYTES_PER_PIXEL * 8;
	m_bmpInfo.bmiHeader.biCompression	= BI_RGB;

	/* DIB ZNVIuWFNg쐬 */
	hDC = GetDC (NULL);
	m_hBmp = CreateDIBSection (hDC, &m_bmpInfo, DIB_RGB_COLORS, (PVOID*)&m_pBits, 0, 0);
	ReleaseDC (NULL, hDC);

	if (m_hBmp == FALSE) {
		goto Exit;
	}

	bRet = TRUE;
Exit:
	return bRet;
}


/* ========================================================================= */
/* ֐F	CImg32::CreateWithoutGdi										 */
/* eF	rbg}bv쐬												 */
/* tF	2005/01/24														 */
/* ========================================================================= */
BOOL CImg32::CreateWithoutGdi(
	int cx,							/* [in]  */
	int cy,							/* [in]  */
	LPBYTE pBits /* = NULL */)		/* [in] rbgf[^ */
{
	BOOL bRet;

	bRet = FALSE;

	if (m_hBmp) {
		goto Exit;
	}

	/* rbg}bvݒ */
	ZeroMemory (&m_bmpInfo, sizeof (m_bmpInfo));
	m_bmpInfo.bmiHeader.biSize		= sizeof(BITMAPINFOHEADER);
	m_bmpInfo.bmiHeader.biWidth		= cx;
	m_bmpInfo.bmiHeader.biHeight	= cy;

	/* rbgf[^w肳ĂH */
	if (pBits) {
		m_pBits = pBits;

	} else {
		DWORD dwSize;

		dwSize = BYTES_PER_LINE(cx) * cy;
		m_pBits = new BYTE [dwSize];
		if (m_pBits == NULL) {
			goto Exit;
		}
		ZeroMemory (m_pBits, dwSize);
	}

	/* _~[̃nhݒ */
	m_hBmp = HBITMAP_WITHOUT_GDI;

	bRet = TRUE;
Exit:
	return bRet;
}


/* ========================================================================= */
/* ֐F	CImg32::Destroy													 */
/* eF	j															 */
/* tF	2005/01/24														 */
/* ========================================================================= */
void CImg32::Destroy(void)
{
	Unlock ();

	/* DIB ZNVIuWFNgj */
	if (m_hBmp) {
		if (m_hBmp != HBITMAP_WITHOUT_GDI) {
			DeleteObject (m_hBmp);

		} else {
			delete [] m_pBits;
		}
	}

	InitData ();
}


/* ========================================================================= */
/* ֐F	CImg32::Clear													 */
/* eF	NA															 */
/* tF	2005/01/26														 */
/* ========================================================================= */
void CImg32::Clear(void)
{
	int cx, cy;

	if (m_pBits == NULL) {
		return;
	}

	cx = Width ();
	cy = Height ();
	ZeroMemory (m_pBits, BYTES_PER_LINE(cx) * cy);
}


/* ========================================================================= */
/* ֐F	CImg32::FillRect												 */
/* eF	`hԂ													 */
/* tF	2005/01/26														 */
/* ========================================================================= */
void CImg32::FillRect(
	int x,					/* [in] n_(X) */
	int y,					/* [in] n_(Y) */
	int cx,					/* [in]  */
	int cy,					/* [in]  */
	COLORREF clFill)		/* [in] hԂF */
{
	int i, j;
	PDWORD dst;
	DWORD dwTmp, dwLineDst;
	PBYTE pBitsDst;

	if (m_pBits == NULL) {
		return;
	}

	x = min (x, Width ());
	x = max (x, 0);
	y = min (y, Height ());
	y = max (y, 0);
	if (x + cx > Width ()) {
		cx = Width () - x;
	}
	if (y + cy > Height ()) {
		cy = Height () - y;
	}

	pBitsDst	= m_pBits;
	dwLineDst	= BYTES_PER_LINE(Width ());
	dwTmp = ColorrefToDword (clFill);

	x *= BYTES_PER_PIXEL;
	y = Height () - 1 - y;

	for (j = 0; j < cy; j ++) {
		dst = (PDWORD)(pBitsDst + dwLineDst * (y - j) + x);
		for (i = 0; i < cx; i ++) {
			*dst = dwTmp;
			dst ++;
		}
	}
}


/* ========================================================================= */
/* ֐F	CImg32::ChgLevel												 */
/* eF	xύX														 */
/* tF	2005/01/26														 */
/* ========================================================================= */
void CImg32::ChgLevel(
	int x,				/* [in] n_(X) */
	int y,				/* [in] n_(Y) */
	int cx,				/* [in]  */
	int cy,				/* [in]  */
	BYTE byLevel)		/* [in] xx */
{
	int i, j;
	PDWORD dst;
	DWORD dwLineDst;
	PBYTE pBitsDst;

	if (m_pBits == NULL) {
		return;
	}

	x = min (x, Width ());
	x = max (x, 0);
	y = min (y, Height ());
	y = max (y, 0);
	if (x + cx > Width ()) {
		cx = Width () - x;
	}
	if (y + cy > Height ()) {
		cy = Height () - y;
	}

	pBitsDst	= m_pBits;
	dwLineDst	= BYTES_PER_LINE(Width ());
	byLevel = PercentToHex (byLevel);

	x *= BYTES_PER_PIXEL;
	y = Height () - 1 - y;

	for (j = 0; j < cy; j ++) {
		dst = (PDWORD)(pBitsDst + dwLineDst * (y - j) + x);
		for (i = 0; i < cx; i ++) {
			TARGB tTmp;

			tTmp.ARGB = *dst;
			tTmp.R = tTmp.R + ((int)(-tTmp.R) * (byLevel + 1) >> 8);
			tTmp.G = tTmp.G + ((int)(-tTmp.G) * (byLevel + 1) >> 8);
			tTmp.B = tTmp.B + ((int)(-tTmp.B) * (byLevel + 1) >> 8);
			*dst = tTmp.ARGB;
			dst ++;
		}
	}
}


/* ========================================================================= */
/* ֐F	CImg32::ChgColor												 */
/* eF	FfύX														 */
/* tF	2005/01/26														 */
/* ========================================================================= */
void CImg32::ChgColor(
	int x,				/* [in] n_(X) */
	int y,				/* [in] n_(Y) */
	int cx,				/* [in]  */
	int cy,				/* [in]  */
	COLORREF clChg)		/* [in] Ff */
{
	int i, j;
	PDWORD dst;
	DWORD dwLineDst;
	PBYTE pBitsDst;
	TARGB tChg;

	if (m_pBits == NULL) {
		return;
	}

	if (cx == 0) {
		cx = Width ();
	}
	if (cy == 0) {
		cy = Height ();
	}

	x = min (x, Width ());
	x = max (x, 0);
	y = min (y, Height ());
	y = max (y, 0);
	if (x + cx > Width ()) {
		cx = Width () - x;
	}
	if (y + cy > Height ()) {
		cy = Height () - y;
	}

	pBitsDst	= m_pBits;
	dwLineDst	= BYTES_PER_LINE(Width ());
	tChg.ARGB = ColorrefToDword (clChg);

	x *= BYTES_PER_PIXEL;
	y = Height () - 1 - y;

	for (j = 0; j < cy; j ++) {
		dst = (PDWORD)(pBitsDst + dwLineDst * (y - j) + x);
		for (i = 0; i < cx; i ++) {
			TARGB tTmp;
			BYTE byTmp;

			tTmp.ARGB = *dst;
			byTmp = (BYTE)(0.30 * tTmp.B + 0.59 * tTmp.G + 0.11 * tTmp.R);

			tTmp.R = (BYTE)(double)(((double)byTmp / 255) * tChg.R);
			tTmp.G = (BYTE)(double)(((double)byTmp / 255) * tChg.G);
			tTmp.B = (BYTE)(double)(((double)byTmp / 255) * tChg.B);
			*dst = tTmp.ARGB;
			dst ++;
		}
	}
}


/* ========================================================================= */
/* ֐F	CImg32::Blt														 */
/* eF	`]														 */
/* tF	2005/01/26														 */
/* ========================================================================= */
void CImg32::Blt(
	int dx,				/* [in] n_(X) */
	int dy,				/* [in] n_(Y) */
	int cx,				/* [in]  */
	int cy,				/* [in]  */
	CImg32 *pSrc,		/* [in] ] */
	int sx,				/* [in] ]̎n_(X) */
	int sy,				/* [in] ]̎n_(Y) */
	BOOL bColorKey)		/* [in] J[L[gp */
{
	int i, j;
	PDWORD dst, src;
	DWORD dwKey, dwLineDst, dwLineSrc;
	PBYTE pBitsDst, pBitsSrc;

	if (m_pBits == NULL) {
		return;
	}

	/* WNbsO */
	ClipPos (dx, dy, cx, cy, pSrc, sx, sy);

	pBitsDst	= m_pBits;
	pBitsSrc	= pSrc->GetBits ();
	dwLineDst	= BYTES_PER_LINE(Width ());
	dwLineSrc	= BYTES_PER_LINE(pSrc->Width ());
	dwKey		= pSrc->GetColorKey ();

	dx	*= BYTES_PER_PIXEL;
	dy	= Height () - 1 - dy;
	sx	*= BYTES_PER_PIXEL;
	sy	= pSrc->Height () - 1 - sy;

	/* J[L[gpH */
	if (bColorKey) {
		for (j = 0; j < cy; j ++) {
			dst = (PDWORD)(pBitsDst + dwLineDst * (dy - j) + dx);
			src = (PDWORD)(pBitsSrc + dwLineSrc * (sy - j) + sx);
			for (i = 0; i < cx; i ++) {
				if (dwKey != *src) {
					*dst = *src;
				}
				dst ++;
				src ++;
			}
		}

	} else {
		for (j = 0; j < cy; j ++) {
			CopyMemory (
				pBitsDst + dwLineDst * (dy - j) + dx,
				pBitsSrc + dwLineSrc * (sy - j) + sx,
				cx * BYTES_PER_PIXEL);
		}
	}
}


/* ========================================================================= */
/* ֐F	CImg32::BltLevel												 */
/* eF	xςȂ`]										 */
/* tF	2005/01/26														 */
/* ========================================================================= */
void CImg32::BltLevel(
	int dx,				/* [in] n_(X) */
	int dy,				/* [in] n_(Y) */
	int cx,				/* [in]  */
	int cy,				/* [in]  */
	CImg32 *pSrc,		/* [in] ] */
	int sx,				/* [in] ]̎n_(X) */
	int sy,				/* [in] ]̎n_(Y) */
	BYTE byLevel,		/* [in] x */
	BOOL bColorKey)		/* [in] J[L[gp */
{
	int i, j;
	DWORD dwKey, dwLineDst, dwLineSrc;
	PBYTE pBitsDst, pBitsSrc, pbySrc, pbyDst;

	if (byLevel == 100) {
		Blt (dx, dy, cx, cy, pSrc, sx, sy, bColorKey);
		return;
	}

	if (m_pBits == NULL) {
		return;
	}

	/* WNbsO */
	ClipPos (dx, dy, cx, cy, pSrc, sx, sy);

	pBitsDst	= m_pBits;
	pBitsSrc	= pSrc->GetBits ();
	dwLineDst	= BYTES_PER_LINE(Width ());
	dwLineSrc	= BYTES_PER_LINE(pSrc->Width ());
	dwKey		= pSrc->GetColorKey ();
	byLevel		= PercentToHex (byLevel);

	dx	*= BYTES_PER_PIXEL;
	dy	= Height () - 1 - dy;
	sx	*= BYTES_PER_PIXEL;
	sy	= pSrc->Height () - 1 - sy;

	/* J[L[gpH */
	if (bColorKey) {
		for (j = 0; j < cy; j ++) {
			pbyDst = pBitsDst + dwLineDst * (dy - j) + dx;
			pbySrc = pBitsSrc + dwLineSrc * (sy - j) + sx;
			for (i = 0; i < cx; i ++) {
				if (memcmp (&dwKey, pbySrc, BYTES_PER_PIXEL)) {
					pbyDst[2] = pbySrc[2] + ((int)(-pbySrc[2]) * (byLevel + 1) >> 8);
					pbyDst[0] = pbySrc[0] + ((int)(-pbySrc[0]) * (byLevel + 1) >> 8);
					pbyDst[1] = pbySrc[1] + ((int)(-pbySrc[1]) * (byLevel + 1) >> 8);
				}
				pbyDst += BYTES_PER_PIXEL;
				pbySrc += BYTES_PER_PIXEL;
			}
		}

	} else {
		for (j = 0; j < cy; j ++) {
			pbyDst = pBitsDst + dwLineDst * (dy - j) + dx;
			pbySrc = pBitsSrc + dwLineSrc * (sy - j) + sx;
			for (i = 0; i < cx; i ++) {
				pbyDst[2] = pbySrc[2] + ((int)(-pbySrc[2]) * (byLevel + 1) >> 8);
				pbyDst[0] = pbySrc[0] + ((int)(-pbySrc[0]) * (byLevel + 1) >> 8);
				pbyDst[1] = pbySrc[1] + ((int)(-pbySrc[1]) * (byLevel + 1) >> 8);

				pbyDst += BYTES_PER_PIXEL;
				pbySrc += BYTES_PER_PIXEL;
			}
		}
	}
}


/* ========================================================================= */
/* ֐F	CImg32::BltAlpha												 */
/* eF	킹`]												 */
/* tF	2005/01/26														 */
/* ========================================================================= */
void CImg32::BltAlpha(
	int dx,				/* [in] n_(X) */
	int dy,				/* [in] n_(Y) */
	int cx,				/* [in]  */
	int cy,				/* [in]  */
	CImg32 *pSrc,		/* [in] ] */
	int sx,				/* [in] ]̎n_(X) */
	int sy,				/* [in] ]̎n_(Y) */
	BYTE byLevel,		/* [in]  */
	BOOL bColorKey)		/* [in] J[L[gp */
{
	int i, j;
	DWORD dwKey, dwLineDst, dwLineSrc;
	PBYTE pBitsDst, pBitsSrc, pbySrc, pbyDst;

	if (m_pBits == NULL) {
		return;
	}

	/* WNbsO */
	ClipPos (dx, dy, cx, cy, pSrc, sx, sy);

	pBitsDst	= m_pBits;
	pBitsSrc	= pSrc->GetBits ();
	dwLineDst	= BYTES_PER_LINE(Width ());
	dwLineSrc	= BYTES_PER_LINE(pSrc->Width ());
	dwKey		= pSrc->GetColorKey ();
	byLevel		= PercentToHex (byLevel);

	dx	*= BYTES_PER_PIXEL;
	dy	= Height () - 1 - dy;
	sx	*= BYTES_PER_PIXEL;
	sy	= pSrc->Height () - 1 - sy;

	/* J[L[gpH */
	if (bColorKey) {
		for (j = 0; j < cy; j ++) {
			pbyDst = pBitsDst + dwLineDst * (dy - j) + dx;
			pbySrc = pBitsSrc + dwLineSrc * (sy - j) + sx;
			for (i = 0; i < cx; i ++) {
				if (memcmp (&dwKey, pbySrc, BYTES_PER_PIXEL)) {
					pbyDst[2] = pbyDst[2] + ((int)(pbySrc[2] - pbyDst[2]) * (byLevel + 1) >> 8);
					pbyDst[0] = pbyDst[0] + ((int)(pbySrc[0] - pbyDst[0]) * (byLevel + 1) >> 8);
					pbyDst[1] = pbyDst[1] + ((int)(pbySrc[1] - pbyDst[1]) * (byLevel + 1) >> 8);
				}
				pbyDst += BYTES_PER_PIXEL;
				pbySrc += BYTES_PER_PIXEL;
			}
		}

	} else {
		for (j = 0; j < cy; j ++) {
			pbyDst = pBitsDst + dwLineDst * (dy - j) + dx;
			pbySrc = pBitsSrc + dwLineSrc * (sy - j) + sx;
			for (i = 0; i < cx; i ++) {
				pbyDst[2] = pbyDst[2] + ((int)(pbySrc[2] - pbyDst[2]) * (byLevel + 1) >> 8);
				pbyDst[0] = pbyDst[0] + ((int)(pbySrc[0] - pbyDst[0]) * (byLevel + 1) >> 8);
				pbyDst[1] = pbyDst[1] + ((int)(pbySrc[1] - pbyDst[1]) * (byLevel + 1) >> 8);

				pbyDst += BYTES_PER_PIXEL;
				pbySrc += BYTES_PER_PIXEL;
			}
		}
	}
}


/* ========================================================================= */
/* ֐F	CImg32::BltAlpha2												 */
/* eF	J[L[̂ݍ킹`]								 */
/* tF	2005/01/26														 */
/* ========================================================================= */
void CImg32::BltAlpha2(
	int dx,				/* [in] n_(X) */
	int dy,				/* [in] n_(Y) */
	int cx,				/* [in]  */
	int cy,				/* [in]  */
	CImg32 *pSrc,		/* [in] ] */
	int sx,				/* [in] ]̎n_(X) */
	int sy,				/* [in] ]̎n_(Y) */
	BYTE byLevelAlpha,	/* [in]  */
	BOOL bColorKey)		/* [in] J[L[gp */
{
	int i, j;
	DWORD dwKey, dwLineDst, dwLineSrc;
	PBYTE pBitsDst, pBitsSrc, pbySrc, pbyDst;

	if (m_pBits == NULL) {
		return;
	}

	/* WNbsO */
	ClipPos (dx, dy, cx, cy, pSrc, sx, sy);

	pBitsDst		= m_pBits;
	pBitsSrc		= pSrc->GetBits ();
	dwLineDst		= BYTES_PER_LINE(Width ());
	dwLineSrc		= BYTES_PER_LINE(pSrc->Width ());
	dwKey			= pSrc->GetColorKey ();
	byLevelAlpha	= PercentToHex (byLevelAlpha);

	dx	*= BYTES_PER_PIXEL;
	dy	= Height () - 1 - dy;
	sx	*= BYTES_PER_PIXEL;
	sy	= pSrc->Height () - 1 - sy;

	/* J[L[gpH */
	if (bColorKey) {
		for (j = 0; j < cy; j ++) {
			pbyDst = pBitsDst + dwLineDst * (dy - j) + dx;
			pbySrc = pBitsSrc + dwLineSrc * (sy - j) + sx;
			for (i = 0; i < cx; i ++) {
				if (memcmp (&dwKey, pbySrc, BYTES_PER_PIXEL) == 0) {
					pbyDst[2] = pbyDst[2] + ((int)(pbySrc[2] - pbyDst[2]) * (byLevelAlpha + 1) >> 8);
					pbyDst[0] = pbyDst[0] + ((int)(pbySrc[0] - pbyDst[0]) * (byLevelAlpha + 1) >> 8);
					pbyDst[1] = pbyDst[1] + ((int)(pbySrc[1] - pbyDst[1]) * (byLevelAlpha + 1) >> 8);
				} else {
					CopyMemory (pbyDst, pbySrc, BYTES_PER_PIXEL);
				}
				pbyDst += BYTES_PER_PIXEL;
				pbySrc += BYTES_PER_PIXEL;
			}
		}

	} else {
		for (j = 0; j < cy; j ++) {
			pbyDst = pBitsDst + dwLineDst * (dy - j) + dx;
			pbySrc = pBitsSrc + dwLineSrc * (sy - j) + sx;
			for (i = 0; i < cx; i ++) {
				pbyDst[2] = pbyDst[2] + ((int)(pbySrc[2] - pbyDst[2]) * (byLevelAlpha + 1) >> 8);
				pbyDst[0] = pbyDst[0] + ((int)(pbySrc[0] - pbyDst[0]) * (byLevelAlpha + 1) >> 8);
				pbyDst[1] = pbyDst[1] + ((int)(pbySrc[1] - pbyDst[1]) * (byLevelAlpha + 1) >> 8);

				pbyDst += BYTES_PER_PIXEL;
				pbySrc += BYTES_PER_PIXEL;
			}
		}
	}
}


/* ========================================================================= */
/* ֐F	CImg32::BltTurnRightAndLeft										 */
/* eF	E]ċ`]											 */
/* tF	2005/01/27														 */
/* ========================================================================= */
void CImg32::BltTurnRightAndLeft(
	int dx,				/* [in] n_(X) */
	int dy,				/* [in] n_(Y) */
	int cx,				/* [in]  */
	int cy,				/* [in]  */
	CImg32 *pSrc,		/* [in] ] */
	int sx,				/* [in] ]̎n_(X) */
	int sy,				/* [in] ]̎n_(Y) */
	BOOL bColorKey)		/* [in] J[L[gp */
{
	int i, j;
	PDWORD dst, src;
	DWORD dwKey, dwLineDst, dwLineSrc;
	PBYTE pBitsDst, pBitsSrc;

	if (m_pBits == NULL) {
		return;
	}

	/* WNbsO */
	ClipPos (dx, dy, cx, cy, pSrc, sx, sy);

	pBitsDst	= m_pBits;
	pBitsSrc	= pSrc->GetBits ();
	dwLineDst	= BYTES_PER_LINE(Width ());
	dwLineSrc	= BYTES_PER_LINE(pSrc->Width ());
	dwKey		= pSrc->GetColorKey ();

	dx	*= BYTES_PER_PIXEL;
	dy	= Height () - 1 - dy;
	sx	*= BYTES_PER_PIXEL;
	sy	= pSrc->Height () - 1 - sy;

	/* J[L[gpH */
	if (bColorKey) {
		for (j = 0; j < cy; j ++) {
			dst = (PDWORD)(pBitsDst + dwLineDst * (dy - j) + dx);
			src = (PDWORD)(pBitsSrc + dwLineSrc * (sy - j) + (sx + cx - BYTES_PER_PIXEL));
			for (i = 0; i < cx; i ++) {
				if (dwKey != *src) {
					*dst = *src;
				}
				dst ++;
				src --;
			}
		}

	} else {
		for (j = 0; j < cy; j ++) {
			dst = (PDWORD)(pBitsDst + dwLineDst * (dy - j) + dx);
			src = (PDWORD)(pBitsSrc + dwLineSrc * (sy - j) + (sx + cx - BYTES_PER_PIXEL));
			for (i = 0; i < cx; i ++) {
				*dst = *src;

				dst ++;
				src --;
			}
		}
	}
}


/* ========================================================================= */
/* ֐F	CImg32::BltTurnUpAndDown										 */
/* eF	㉺]ċ`]											 */
/* tF	2005/01/27														 */
/* ========================================================================= */
void CImg32::BltTurnUpAndDown(
	int dx,				/* [in] n_(X) */
	int dy,				/* [in] n_(Y) */
	int cx,				/* [in]  */
	int cy,				/* [in]  */
	CImg32 *pSrc,		/* [in] ] */
	int sx,				/* [in] ]̎n_(X) */
	int sy,				/* [in] ]̎n_(Y) */
	BOOL bColorKey)		/* [in] J[L[gp */
{
	int i, j;
	PDWORD dst, src;
	DWORD dwKey, dwLineDst, dwLineSrc;
	PBYTE pBitsDst, pBitsSrc;

	if (m_pBits == NULL) {
		return;
	}

	/* WNbsO */
	ClipPos (dx, dy, cx, cy, pSrc, sx, sy);

	pBitsDst	= m_pBits;
	pBitsSrc	= pSrc->GetBits ();
	dwLineDst	= BYTES_PER_LINE(Width ());
	dwLineSrc	= BYTES_PER_LINE(pSrc->Width ());
	dwKey		= pSrc->GetColorKey ();

	dx	*= BYTES_PER_PIXEL;
	dy	= Height () - 1 - dy;
	sx	*= BYTES_PER_PIXEL;
	sy	= pSrc->Height () - 1 - sy;

	/* J[L[gpH */
	if (bColorKey) {
		for (j = 0; j < cy; j ++) {
			dst = (PDWORD)(pBitsDst + dwLineDst * (dy - j) + dx);
			src = (PDWORD)(pBitsSrc + dwLineSrc * (sy - cy + j - 1) + sx);
			for (i = 0; i < cx; i ++) {
				if (dwKey != *src) {
					*dst = *src;
				}
				dst ++;
				src ++;
			}
		}

	} else {
		for (j = 0; j < cy; j ++) {
			dst = (PDWORD)(pBitsDst + dwLineDst * (dy - j) + dx);
			src = (PDWORD)(pBitsSrc + dwLineSrc * (sy - cy + j - 1) + sx);
			for (i = 0; i < cx; i ++) {
				*dst = *src;

				dst ++;
				src ++;
			}
		}
	}
}


/* ========================================================================= */
/* ֐F	CImg32::Lock													 */
/* eF	摜bN													 */
/* tF	2005/01/26														 */
/* ========================================================================= */
HDC CImg32::Lock(void)
{
	HDC hDC, hRet;

	hRet = NULL;
	/* IuWFNgs */
	if ((m_hBmp == NULL )|| (m_hBmp == HBITMAP_WITHOUT_GDI)) {
		goto Exit;
	}

	/* łɃbNĂ */
	if (m_hDC) {
		hRet = m_hDC;
		goto Exit;
	}

	/* Rp`u DC 쐬āArbg}bvI */
	hDC = GetDC (NULL);
	m_hDC = CreateCompatibleDC (hDC);
	ReleaseDC (NULL, hDC);
	if (m_hDC) {
		m_hBmpBack = (HBITMAP)SelectObject (m_hDC, m_hBmp);
	}
	hRet = m_hDC;

Exit:
	return hRet;
}


/* ========================================================================= */
/* ֐F	CImg32::Unlock													 */
/* eF	bN														 */
/* tF	2005/01/26														 */
/* ========================================================================= */
void CImg32::Unlock(void)
{
	if (m_hDC == NULL) {
		return;
	}

	SelectObject (m_hDC, m_hBmpBack);
	DeleteDC (m_hDC);
	m_hDC = NULL;
}


/* ========================================================================= */
/* ֐F	CImg32::GetSafeHandle											 */
/* eF	rbg}bvnh擾										 */
/* tF	2005/01/26														 */
/* ========================================================================= */
HBITMAP CImg32::GetSafeHandle(void)
{
	return m_hBmp;
}


/* ========================================================================= */
/* ֐F	CImg32::Width													 */
/* eF	擾														 */
/* tF	2005/01/26														 */
/* ========================================================================= */
int CImg32::Width(void)
{
	int nRet;

	nRet = 0;
	if (m_hBmp == NULL) {
		goto Exit;
	}

	nRet = m_bmpInfo.bmiHeader.biWidth;

Exit:
	return nRet;
}


/* ========================================================================= */
/* ֐F	CImg32::Height													 */
/* eF	擾														 */
/* tF	2005/01/26														 */
/* ========================================================================= */
int CImg32::Height(void)
{
	int nRet;

	nRet = 0;
	if (m_hBmp == NULL) {
		goto Exit;
	}

	nRet = m_bmpInfo.bmiHeader.biHeight;

Exit:
	return nRet;
}


/* ========================================================================= */
/* ֐F	CImg32::GetImageSize											 */
/* eF	f[^TCY擾												 */
/* tF	2005/01/26														 */
/* ========================================================================= */
int CImg32::GetImageSize(void)
{
	int nRet, cx, cy;

	nRet = 0;
	if (m_hBmp == NULL) {
		goto Exit;
	}

	cx = Width ();
	cy = Height ();
	nRet = BYTES_PER_LINE(cx) * cy;

Exit:
	return nRet;
}


/* ========================================================================= */
/* ֐F	CImg32::GetBits													 */
/* eF	rbgf[^̃AhX擾									 */
/* tF	2005/01/26														 */
/* ========================================================================= */
LPBYTE CImg32::GetBits(void)
{
	return m_pBits;
}


/* ========================================================================= */
/* ֐F	CImg32::SetColorKey												 */
/* eF	J[L[ݒ												 */
/* tF	2005/01/26														 */
/* ========================================================================= */
void CImg32::SetColorKey(COLORREF clKey)
{
	m_dwColorKey = ColorrefToDword (clKey);
}


/* ========================================================================= */
/* ֐F	CImg32::GetColorKey												 */
/* eF	J[L[擾												 */
/* tF	2005/01/26														 */
/* ========================================================================= */
COLORREF CImg32::GetColorKey(void)
{
	COLORREF clRet;
	TARGB tTmp;

	tTmp.ARGB = m_dwColorKey;
	clRet = RGB (tTmp.R, tTmp.G, tTmp.B);

	return clRet;
}


/* ========================================================================= */
/* ֐F	CImg32::InitData												 */
/* eF	f[^													 */
/* tF	2005/01/24														 */
/* ========================================================================= */
void CImg32::InitData(void)
{
	m_hBmp = NULL;
	m_hBmpBack = NULL;
	ZeroMemory (&m_bmpInfo, sizeof (m_bmpInfo));
	m_pBits = NULL;
	m_hDC = NULL;
	m_dwColorKey = 0;
}


/* ========================================================================= */
/* ֐F	CImg32::ColorrefToDword											 */
/* eF	FfDWORDlɕϊ												 */
/* tF	2005/01/24														 */
/* ========================================================================= */
DWORD CImg32::ColorrefToDword(COLORREF cl)
{
	DWORD dwRet;

	dwRet  = (cl & 0x000000FF) << 16;
	dwRet |= (cl & 0x0000FF00) << 0;
	dwRet |= (cl & 0x00FF0000) >> 16;

	return dwRet;
}


/* ========================================================================= */
/* ֐F	CImg32::PercentToHex											 */
/* eF	p[Zg255MAX16iɕϊ								 */
/* tF	2005/01/24														 */
/* ========================================================================= */
BYTE CImg32::PercentToHex(BYTE byPercent)
{
	BYTE byRet;

	byRet = 255 - (byPercent * 255 / 100);

	return byRet;
}


/* ========================================================================= */
/* ֐F	CImg32::ClipPos													 */
/* eF	WNbsO												 */
/* tF	2005/01/28														 */
/* ========================================================================= */
void CImg32::ClipPos(
	int &dx,			/* [in,ou]	n_(X) */
	int &dy,			/* [in,ou]	n_(Y) */
	int &cx,			/* [in,ou]	 */
	int &cy,			/* [in,ou]	 */
	CImg32 *pSrc,		/* [in]		] */
	int &sx,			/* [in,ou]	]̎n_(X) */
	int &sy)			/* [in,ou]	]̎n_(Y) */
{
	int dxBack, dyBack, cxBack, cyBack, sxBack, syBack;
	RECT rc1, rc2, rcTmp;

	dxBack = dx;
	dyBack = dy;
	cxBack = cx;
	cyBack = cy;
	sxBack = sx;
	syBack = sy;

	/* ]NbsO */
	SetRect (&rc1, sx, sy, sx + cx, sy + cy);
	SetRect (&rc2, 0, 0, pSrc->Width (), pSrc->Height ());
	IntersectRect (&rcTmp, &rc1, &rc2);
	sx = rcTmp.left;
	sy = rcTmp.top;
	cx = rcTmp.right - rcTmp.left;
	cy = rcTmp.bottom - rcTmp.top;

	/* ]NbsO */
	SetRect (&rc1, dx, dy, dx + cx, dy + cy);
	SetRect (&rc2, 0, 0, Width (), Height ());
	IntersectRect (&rcTmp, &rc1, &rc2);
	dx = rcTmp.left;
	dy = rcTmp.top;
	cx = rcTmp.right - rcTmp.left;
	cy = rcTmp.bottom - rcTmp.top;

	if (dy > dyBack) {
		sy += (cyBack - cy);
	}
	if (dx > dxBack) {
		sx += (cxBack - cx);
	}
}

/* Copyright(C)URARA-works 2005 */
