/* Copyright(C)URARA-works 2005 */
/* ========================================================================= */
/* t@CF	MyArrayImpl.h												 */
/* eF		MFCCArray݂ȔzNX t@C					 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2005/01/18													 */
/* ========================================================================= */

#ifndef MYARRAYIMPLE_H
#define MYARRAYIMPLE_H


/* ========================================================================= */
/* ֐F	CmyArray<TYPE, ARG_TYPE>::CmyArray								 */
/* eF	RXgN^													 */
/* tF	2005/01/18														 */
/* ========================================================================= */

template<class TYPE, class ARG_TYPE>
CmyArray<TYPE, ARG_TYPE>::CmyArray()
{
	m_pData = NULL;
	m_nCount = 0;
}


/* ========================================================================= */
/* ֐F	CmyArray<TYPE, ARG_TYPE>::~CmyArray								 */
/* eF	fXgN^													 */
/* tF	2005/01/18														 */
/* ========================================================================= */

template<class TYPE, class ARG_TYPE>
CmyArray<TYPE, ARG_TYPE>::~CmyArray()
{
	RemoveAll ();
}


/* ========================================================================= */
/* ֐F	CmyArray<TYPE, ARG_TYPE>::GetSize								 */
/* eF	vf擾													 */
/* ߂lF	vf															 */
/* tF	2005/01/18														 */
/* ========================================================================= */

template<class TYPE, class ARG_TYPE>
int CmyArray<TYPE, ARG_TYPE>::GetSize(void)
{
	return m_nCount;
}


/* ========================================================================= */
/* ֐F	CmyArray<TYPE, ARG_TYPE>::RemoveAll								 */
/* eF	Svf폜													 */
/* tF	2005/01/18														 */
/* ========================================================================= */

template<class TYPE, class ARG_TYPE>
void CmyArray<TYPE, ARG_TYPE>::RemoveAll(void)
{
	if (m_pData) {
		delete [] m_pData;
		m_pData = NULL;
	}
	m_nCount = 0;
}


/* ========================================================================= */
/* ֐F	CmyArray<TYPE, ARG_TYPE>::GetAt									 */
/* eF	wvf擾													 */
/* ߂lF	vf̃f[^													 */
/* tF	2005/01/18														 */
/* ========================================================================= */

template<class TYPE, class ARG_TYPE>
TYPE CmyArray<TYPE, ARG_TYPE>::GetAt(
	int nIndex)		/* [in] vfID */
{
	TYPE Ret;

	ZeroMemory (&Ret, sizeof (TYPE));

	if (nIndex >= m_nCount) {
		goto Exit;
	}

	Ret = m_pData[nIndex];

Exit:
	return Ret;
}


/* ========================================================================= */
/* ֐F	CmyArray<TYPE, ARG_TYPE>::SetAt									 */
/* eF	wvfXV													 */
/* tF	2005/01/18														 */
/* ========================================================================= */

template<class TYPE, class ARG_TYPE>
void CmyArray<TYPE, ARG_TYPE>::SetAt(
	int nIndex,					/* [in] vfID */
	ARG_TYPE newElement)		/* [in] Vf[^ */
{
	if (nIndex >= m_nCount) {
		goto Exit;
	}

	m_pData[nIndex] = newElement;

Exit:
	return;
}


/* ========================================================================= */
/* ֐F	CmyArray<TYPE, ARG_TYPE>::Add									 */
/* eF	vfǉ														 */
/* ߂lF	ǉꂽvfID												 */
/* tF	2005/01/18														 */
/* ========================================================================= */

template<class TYPE, class ARG_TYPE>
int CmyArray<TYPE, ARG_TYPE>::Add(
	ARG_TYPE newElement)		/* [in] ǉf[^ */
{
	TYPE *pData;

	/* ǉ̗vfm */
	pData = new TYPE[m_nCount + 1];

	/* ǉÕf[^Rs[ */
	CopyMemory (pData, m_pData, sizeof (TYPE) * m_nCount);
	pData[m_nCount] = newElement;

	if (m_pData) {
		/* ܂ł̃f[^j */
		delete [] m_pData;
	}

	m_pData = pData;
	m_nCount ++;

	/* VIDԂ */
	return (m_nCount - 1);
}


/* ========================================================================= */
/* ֐F	CmyArray<TYPE, ARG_TYPE>::InsertAt								 */
/* eF	wʒuɒǉ													 */
/* tF	2005/08/19														 */
/* ========================================================================= */

template<class TYPE, class ARG_TYPE>
void CmyArray<TYPE, ARG_TYPE>::InsertAt(
	int nIndex,					/* [in] vfID */
	ARG_TYPE newElement)		/* [in] ǉf[^ */
{
	int i, nTmp;
	TYPE *pData;

	/* ǉ̗vfm */
	pData = new TYPE[m_nCount + 1];

	nTmp = 0;
	/* ǉÕf[^Rs[ */
	for (i = 0; i < m_nCount + 1; i ++) {
		if (i == nIndex) {
			continue;
		}
		CopyMemory (&pData[i], &m_pData[nTmp], sizeof (TYPE));
		nTmp ++;
	}
	pData[nIndex] = newElement;

	if (m_pData) {
		/* ܂ł̃f[^j */
		delete [] m_pData;
	}

	m_pData = pData;
	m_nCount ++;
}


/* ========================================================================= */
/* ֐F	CmyArray<TYPE, ARG_TYPE>::RemoveAt								 */
/* eF	wvf폜													 */
/* tF	2005/01/18														 */
/* ========================================================================= */

template<class TYPE, class ARG_TYPE>
void CmyArray<TYPE, ARG_TYPE>::RemoveAt(
	int nIndex,		/* [in] vfID */
	int nCount)		/* [in] 폜 */
{
	int i, j, nID;
	TYPE *pData;

	/* w蕪vf폜郋[v */
	for (j = 0; j < nCount; j ++) {
		/* z񂩂͂ݏoH */
		if (nIndex >= m_nCount) {
			break;
		}

		/* 폜̃f[^m */
		pData = new TYPE[m_nCount - 1];
		/* wvfȊORs[郋[v */
		for (i = 0, nID = 0; i < m_nCount; i ++) {
			if (nIndex == i) {
				continue;
			}
			pData[nID] = m_pData[i];
			nID ++;
		}
		if (m_pData) {
			delete [] m_pData;
		}
		m_pData = pData;
		m_nCount --;
	}
}


/* ========================================================================= */
/* ֐F	CmyArray<TYPE, ARG_TYPE>::Copy									 */
/* eF	Rs[															 */
/* tF	2005/06/03														 */
/* ========================================================================= */

template<class TYPE, class ARG_TYPE>
void CmyArray<TYPE, ARG_TYPE>::Copy(
	CmyArray *pSrc)		/* [in] Rs[ */
{
	int i, nCount;

	RemoveAll ();
	nCount = pSrc->GetSize ();
	for (i = 0; i < nCount; i ++) {
		Add (pSrc->GetAt (i));
	}
}


/* ========================================================================= */
/* ֐F	CmyArray<TYPE, ARG_TYPE>::operator []							 */
/* eF	wvf֒ڃANZX											 */
/* ߂lF	vf															 */
/* tF	2005/01/18														 */
/* ========================================================================= */

template<class TYPE, class ARG_TYPE>
TYPE& CmyArray<TYPE, ARG_TYPE>::operator [](
	int nIndex)		/* [in] vfID */
{
	return m_pData[nIndex];
}

#endif
/* Copyright(C)URARA-works 2005 */
